/*
 * Test.java
 * Task:  Test harness for assignment 2
 *
 * By:  Ron Ritchey
 * Oct 7, 2007
 *
 *
 */


import java.io.*;
import java.util.TreeSet;
import java.util.Iterator;
import java.util.logging.*;
import java.util.regex.*;



public class Test {

 	private static Logger logger =
	  Logger.getLogger(Test.class.getName());

	static String validate(String input) {

		String[] blacklist = new String[] { "badword", "dirtyword" };
		for (int i = 0; i < blacklist.length; i++) {
			int index;
			do {
				index = input.indexOf(blacklist[i]);
				if (index != -1) {
					String b = input.substring(0,index);
					String e = input.substring(index+blacklist[i].length(), input.length());
					input = b + e;
				}
			} while (index != -1);
		}
		return input;
	}



    public static void main(String[] arg) throws InvalidPersonException, InvalidTelephoneException {
		System.out.println("Test of new person and telephone objects");


		String[] peeps = { "Ron Ritchey",
		                   "Ritchey, Ron",
		                   "Ritchey, Ronald Wayne",
		                   "Ronald Wayne Ritchey",
		                   "Ronald W Ritchey",
		                   "Ronald W. Ritchey",
		                   "John O'Malley",
		                   "Susan O'Malley-Smith",
		                   "John The-Rock Edwards",
		                   "Tiny" };
		String[] telNrs = { "12345",
		                    "(703) 111-2121",
		                    "123-1234",
		                    "+1(703) 111-2121",
		                    "+32 (21) 212-2324",
		                    "1(703)123-1234",
		                    "1(703) 123-1234",
		                    "1 (703) 123-1234",
		                    "1(703) 123/1234",
		                    "1/703/123/1234",
		                    "123.1234",
		                    "011 701 111 1234",
		                    "12345.12345",
		                    "011 703 111 1234",
		                    "011 1 703 111 1234",
		                    "123",
		                    "12.34.56.78",
		                    "002 123 123-1234",
		                    "nr 102-102-1234",
		                    "<script>alert(\"XSS\")</script>",
		                    "'",
		                    "+1234 (201) 123-1234",
		                    "(001) 123-1234",
		                    "+01 (703) 123-1234" };

		Person p;

		System.out.println("Starting Name Test");
		System.out.println("------------------");
		for (int i = 0; i < peeps.length; i++) {
			try {
				p = new Person(peeps[i]);
				System.out.println(peeps[i] + " is accepted as " + p.getName());
			} catch(InvalidPersonException e) {
				System.out.println(peeps[i] + " was not accepted");
			}
		}

		Telephone t;

		System.out.println("Starting Telephone Test");
		System.out.println("------------------");
		for (int i = 0; i < telNrs.length; i++) {
			try {
				t = new Telephone(telNrs[i]);
				System.out.println(telNrs[i] + " is accepted as " + t.getNumber());
			} catch(InvalidTelephoneException e) {
				System.out.println(telNrs[i] + " was not accepted");
			}
		}


		// blacklist test
		System.out.println("Blacklist Test");
		System.out.println("------------------");

		String ts = new String("This sentence has a badword in it");
	 	System.out.println("Input : " + ts);
		System.out.println("Output: " + validate(ts));

		ts = new String("This sentence has a badbadwordword in it");
		System.out.println("Input : " + ts);
		System.out.println("Output: " + validate(ts));

		ts = new String("This sentence has a baddirtywordword in it");
		System.out.println("Input : " + ts);
		System.out.println("Output: " + validate(ts));

		ts = new String("This sentence has a dirtybadwordword in it");
		System.out.println("Input : " + ts);
		System.out.println("Output: " + validate(ts));


		Pattern p1 = Pattern.compile("[a-zA-Z]+[0-9]");
		Matcher m1 = p1.matcher("alpha9");
		if (m1.find()) System.out.println("alpha9 found");
		else System.out.println("alpha9 not found");
		 m1 = p1.matcher("Beta66");
		if (m1.find()) System.out.println("Beta66 found");
		else System.out.println("Beta66 not found");
		m1 = p1.matcher("99Delta");
		if (m1.find()) System.out.println("99Delta found");
		else System.out.println("99Delta not found");
		 m1 = p1.matcher("9Gamma9");
		if (m1.find()) System.out.println("9Gamma9 found");
		else System.out.println("9Gamma9 not found");
	}

}
